
#include "AppEvent.Ch"
#include "DcBitMap.Ch"
#include "DcCursor.Ch"
#include "DcDialog.Ch"
#include "DcGra.Ch"
#include "DcIcon.Ch"
#include "Inkey.Ch"
#include "Xbp.Ch"
#include "XbpDev.Ch"

#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_CAPITAL        0x14
#define APPKEY_PRESSED    2

FUNCTION Main

  LOCAL GetList[0], n := 1, GetOptions, aPres, aBrowPres, lStatus, oStatBar, oMsgStatic, oInsStatic, oNumStatic, oCapsStatic, oMsgBox, nRow := 0, lRow := .f., ;
        oBrowse1, aColor, cAppDesc

  PRIVATE aArMenu01, oB

  n              := 1
  nRow           := 0
  cAppDesc       := "Alarm Registration System"
  lStatus        := .f.

/*

					         Element  1 - Program Description
					         Element  2 - Program Name
					         Element  3 - Edit Allowed to [Access]
					         Element  4 - Edit Allowed to [Modify]
					         Element  5 - Edit Allowed to [Delete]
					         Element  6 - Edit Allowed to [Print]
					         Element  7 - Authorized for [Access]
					         Element  8 - Authorized for [Modify]
					         Element  9 - Authorized for [Delete]
					         Element 10 - Authorized for [Print]

*/

  aArMenu01      := { {"Maintain Alarm Function Code."                              , "ARP600N4"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Alarm Type Code."                                  , "ARP600N3"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Industry Code."                                    , "ARP600N0"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Medical Condition Code."                           , "ARP600N1"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Systems Present Code."                             , "ARP600N2"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {""                                                           , ""          , .f., .f., .f., .f., .f., .f., .f., .f.}, ;  // Spacer
                      {"Maintain Department Personnel."                             , "MVP630"    , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Gender Code."                                      , "ARP600K5"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {'Maintain Location "Alias" Addresses.'                       , "MVP160"    , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Race Code."                                        , "ARP600K4"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Rank Code."                                        , "ARP60020"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain State Code."                                       , "ARP600M1"  , .t., .t., .t., .t., .f., .f., .f., .f.}, ;
                      {"Maintain Specialties Code."                                 , "ARP600M1"  , .t., .t., .t., .t., .f., .f., .f., .f.} }


  aColor         := { {GRA_CLR_WHITE,Nil}, ;
                      {GRA_CLR_WHITE,GRA_CLR_DARKRED} }

  aPres          := DC_BrowPres()

  aBrowPres      := { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                      { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                      { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                      { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                      { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                      { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                      { XBP_PP_COL_DA_ROWHEIGHT, 12 },                    /* Row Height       */  ;
                      { XBP_PP_COL_DA_CELLHEIGHT, 12 },                   /* Cell Height      */  ;
                      { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                      { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                      { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                      { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                      { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                      { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                      { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                      { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                      { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                      { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                      { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
                    }

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors



  @   .75, 1.00 DCSAY {|| cAppDesc }                                                SAYSIZE 80                                                            COLOR GRA_CLR_BLUE ;
					 FONT "14.CAMPBELL"                                                  SAYCENTER


  @  2.25, 0.00 DCBROWSE oBrowse1      DATA aArMenu01                               SIZE  80.00, 25.60 ;
                FIT ;
                POINTER n ;
 			 		 NOHSCROLL ;
			 		 HEADLINES 2 ;
					 ID "oBrowse1" ;
                PRESENTATION DC_BrowPres()

  DCBROWSECOL   DATA {|x| x := DC_GetColArray(1,oBrowse1) }                                                                           PARENT oBrowse1 ;
					 WIDTH 30 ;
					 HEADER ';Program Description' ;
			       DATATOOLTIP {|| .t. }  TIPBLOCK {|nRow| aArMenu01[nRow,2] }

  DCBROWSECOL   DATA {|x| x := DC_GetColArray(7,oBrowse1), IIF(x,BITMAP_CHECKBOX_CHECKED_S, BITMAP_CHECKBOX_UNCHECKED_S) }            PARENT oBrowse1 ;
                WIDTH 4 ;
                HEADER ';Access' ;
                TYPE XBPCOL_TYPE_BITMAP ;
					 COLOR {|x| x := IIF( DC_GetColArray(3,oBrowse1),aColor[1], aColor[2]) } ;
                EVAL BrowBlock( 2, 7, @n, aArMenu01, @oBrowse1, GetList ) ;

  DCBROWSECOL   DATA {|x| x := DC_GetColArray(8,oBrowse1), IIF(x,BITMAP_CHECKBOX_CHECKED_S, BITMAP_CHECKBOX_UNCHECKED_S) }            PARENT oBrowse1 ;
                WIDTH 4 ;
                HEADER 'Add /;Modify' ;
                TYPE XBPCOL_TYPE_BITMAP ;
					 COLOR {|x| x := IIF( DC_GetColArray(4,oBrowse1),aColor[1], aColor[2]) } ;
                EVAL BrowBlock( 3, 8, @n, aArMenu01, @oBrowse1, GetList ) ;

  DCBROWSECOL   DATA {|x| x := DC_GetColArray(9,oBrowse1), IIF(x,BITMAP_CHECKBOX_CHECKED_S, BITMAP_CHECKBOX_UNCHECKED_S) }            PARENT oBrowse1 ;
                WIDTH 4 ;
                HEADER ';Delete' ;
                TYPE XBPCOL_TYPE_BITMAP ;
					 COLOR {|x| x := IIF( DC_GetColArray(5,oBrowse1),aColor[1], aColor[2]) } ;
                EVAL BrowBlock( 4, 9, @n, aArMenu01, @oBrowse1, GetList ) ;


  DCBROWSECOL   DATA {|x| x := DC_GetColArray(10,oBrowse1), IIF(x,BITMAP_CHECKBOX_CHECKED_S, BITMAP_CHECKBOX_UNCHECKED_S) }           PARENT oBrowse1 ;
                WIDTH 4 ;
                HEADER ';Print' ;
                TYPE XBPCOL_TYPE_BITMAP ;
					 COLOR {|x| x := IIF( DC_GetColArray(6,oBrowse1),aColor[1], aColor[2]) } ;
                EVAL BrowBlock( 5, 10, @n, aArMenu01, @oBrowse1, GetList ) ;


  @ 28.50, 2.00 DCPUSHBUTTON           CAPTION 'Update'                             SIZE  9.00, 1.20 ;
                ACTION {|| ProcessAr(), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 28.50,12.00 DCPUSHBUTTON           CAPTION 'Exit'                               SIZE  9.00, 1.20 ;
					 CARGO "CANCEL" ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @ 28.50,59.00 DCPUSHBUTTON           CAPTION 'Select All'                         SIZE  9.00, 1.20 ;
                ACTION {|| SelectAll( oBrowse1, GetList) }

  @ 28.50,69.00 DCPUSHBUTTON           CAPTION 'Deny All'                           SIZE  9.00, 1.20 ;
                ACTION {|| DenyAll( oBrowse1, GetList) }


  DCSTATUSBAR oStatBar HEIGHT 25 ALIGN DCGUI_ALIGN_BOTTOM SPACING 0

  @  3.00, 0.00 DCSTATIC               TYPE XBPSTATIC_TYPE_RECESSEDBOX 			      SIZE 300,20 			         PIXEL               PARENT oStatBar     OBJECT oMsgStatic

  @  2.00, 2.00 DCMESSAGEBOX           TYPE XBPSTATIC_TYPE_TEXT                     SIZE 300,20                   PIXEL               PARENT oMsgStatic   OBJECT oMsgBox ;
                                                                                                                                                          COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  3.00, 0.00 DCSTATIC               TYPE XBPSTATIC_TYPE_RECESSEDBOX 			      SIZE 30,20                    PIXEL               PARENT oStatBar     OBJECT oCapsStatic

  @  1.00, 1.00 DCSAY ''               ID 'CAPSLOCK' 			                        SAYSIZE 28,18  SAYCENTER      PIXEL               PARENT oCapsStatic

  @  3.00, 0.00 DCSTATIC               TYPE XBPSTATIC_TYPE_RECESSEDBOX 			      SIZE 30,20                    PIXEL               PARENT oStatBar     OBJECT oNumStatic

  @  1.00, 1.00 DCSAY ''               ID 'NUMLOCK' 			                        SAYSIZE 28,18  SAYCENTER      PIXEL               PARENT oNumStatic

  @  3.00, 0.00 DCSTATIC               TYPE XBPSTATIC_TYPE_RECESSEDBOX 			      SIZE 30,20                    PIXEL               PARENT oStatBar     OBJECT oInsStatic

  @  1.00, 1.00 DCSAY ''               ID 'INSERT' 			                        SAYSIZE 28,18  SAYCENTER      PIXEL               PARENT oInsStatic

  DCHOTKEY K_INS ACTION {|| ReadInsert(!ReadInsert()) }

  DCGETOPTIONS ;
    CASCADE ;
	 NOMAXBUTTON ;
    SOURCEFILE __FILEPATH__ ;
    TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW


  DCREAD GUI ;
         FIT ;
         MODAL ;
         OPTIONS GetOptions ;
         TITLE 'Maintain Security Options'


  DC_BrowPres(aPres)                                           // save browse presentation factors

RETURN Nil

*---

STATIC FUNCTION BrowBlock( nCol, nElement, n, aArMenu01, oBrowse1, GetList )

RETURN {|oB| oB:dataArea:lbClick := {|a,b,o| IIF(oBrowse1:colPos == nCol, ;
             (IIF(!Empty(aArMenu01[n,1]),aArMenu01[n,nElement] := !aArMenu01[n,nElement],nil), ;
             oBrowse1:refreshCurrent()), Nil) }, ;
             oB:heading:rbClick  := {|| FlagCol(nElement, oBrowse1, GetList) } }



STATIC FUNCTION ProcessAr()

	*--- Save Functions Here ---

RETURN Nil

*---

STATIC FUNCTION FlagCol( nCol, oB, GetList )

  LOCAL i

  FOR i := 1 TO Len(aArMenu01)
	 IF aArMenu01[i,nCol-4]
	   IF aArMenu01[i,nCol]
        aArMenu01[i,nCol] := .f.
	   ELSE
        aArMenu01[i,nCol] := .t.
	   ENDIF
	 ENDIF
  NEXT

  oB:refreshAll()
  DC_GetRefresh(GetList)

RETURN Nil

*---

STATIC FUNCTION SelectAll( oB, GetList )

  LOCAL i, nCol

  FOR nCol := 7 TO 10
    FOR i := 1 TO Len(aArMenu01)
	   IF aArMenu01[i,nCol-4]
        aArMenu01[i,nCol] := .t.
	   ENDIF
    NEXT
  NEXT

  oB:refreshAll()
  DC_GetRefresh(GetList)

RETURN Nil

*---

STATIC FUNCTION DenyAll( oB, GetList )

  LOCAL i, nCol

  FOR nCol := 7 TO 10
    FOR i := 1 TO Len(aArMenu01)
	   IF aArMenu01[i,nCol-4]
        aArMenu01[i,nCol] := .f.
	   ENDIF
    NEXT
  NEXT

  oB:refreshAll()
  DC_GetRefresh(GetList)

RETURN Nil

*---

STATIC FUNCTION _UpdateStats( GetList )

  LOCAL oCapsLock := DC_GetObject(GetList,'CAPSLOCK')
  LOCAL oNumLock  := DC_GetObject(GetList,'NUMLOCK')
  LOCAL oInsert   := DC_GetObject(GetList,'INSERT')
  LOCAL lCaps     := AppKeyState( VK_CAPITAL,.t. )
  LOCAL lNum      := AppKeyState( VK_NUMLOCK,.t. )

  IF lNum == APPKEY_PRESSED
    oNumLock:SetCaption( "Num" )
  ELSE
    oNumLock:SetCaption( "" )
  ENDIF

  IF lCaps == APPKEY_PRESSED
    oCapsLock:SetCaption( "Caps" )
  ELSE
    oCapsLock:SetCaption( "" )
  ENDIF

  IF ReadInsert()
    oInsert:SetCaption( "Ins" )
  ELSE
    oInsert:SetCaption( "Ovr" )
  ENDIF

RETURN Nil
